
extern int length = 100;   // The amount of bars sent to be processed
string nameData;

int start()
{
   nameData = Symbol()+Period()+".csv";         // name of the data file to be sent
   static datetime old_time;   // remember the amount of bars already known   
   string symbol = Symbol();
   int TF = Period();
   while(!IsStopped())
   {   
   RefreshRates();
   Print(old_time+" "+Time[0]);
   if (old_time != Time[0])      // if a new bar is received 
   {
   Print("New bar");
   old_time = Time[0];              // remember how many bars are known
        int handle = FileOpen(nameData, FILE_CSV|FILE_READ,';');
        if(handle<0)createFile();else{
         FileClose(handle);
         
        handle = FileOpen(nameData, FILE_CSV|FILE_READ|FILE_WRITE,';');
        int count=0;
        int size = 500;
        if(size>FileSize(handle))size = FileSize(handle);
        if(!FileSeek(handle,size*(-1),SEEK_END))Print("Error "+GetLastError());
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle))count++;
        }
        FileSeek(handle,size*(-1),SEEK_END);
        int recount = 0;
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle)){
        recount++;
        if(recount==count-2){
        string lastdate = FileReadString(handle);
        string lasttime = FileReadString(handle)+" "+lastdate;
        datetime lastline = StrToTime(lasttime);
        FileSeek(handle,0,SEEK_END);
        if(iBarShift(symbol,TF,lastline)>1){
        int barShift = iBarShift(symbol,TF,lastline);
        if(barShift>2)Print("Updating "+(barShift-1)+" missed "+symbol+"'s "+TF+ " minute bars");
        while(barShift>2)
        {
        FileWrite(handle, TimeToStr(iTime(symbol,TF,barShift), TIME_DATE), TimeToStr(iTime(symbol,TF,barShift), TIME_SECONDS), iHigh(symbol,TF,barShift), iLow(symbol,TF,barShift), iClose(symbol,TF,barShift), iOpen(symbol,TF,barShift), iVolume(symbol,TF,barShift),barShift);
        barShift--;
        }}
        if(lastline!=iTime(symbol,TF,1)){
        Print("Updating "+symbol+" on the "+TF+" minute timeframe"+" "+TimeToStr(iTime(symbol,TF,1), TIME_SECONDS)+" "+TimeToStr(lastline, TIME_DATE)+" "+lasttime); 
        FileWrite(handle, TimeToStr(iTime(symbol,TF,1), TIME_DATE), TimeToStr(iTime(symbol,TF,1), TIME_SECONDS), iHigh(symbol,TF,1), iLow(symbol,TF,1), iClose(symbol,TF,1), iOpen(symbol,TF,1), iVolume(symbol,TF,1));
        }
        break;
        }}
        }
        
        FileClose(handle);                                                  
   }      
   
   }
   int tickcount;
   tickcount = TimeSeconds(TimeCurrent());
   tickcount = 70-tickcount;
   Print("To sleep for "+tickcount+" seconds");
   Sleep(tickcount*1000);
   }
   return(0);
}

void createFile()
{
    int handle = FileOpen(nameData, FILE_CSV|FILE_WRITE,';');
        if(handle < 1)
        {
          Comment("Creation of "+nameData+" failed. Error #", GetLastError());
          return(0);
        }
        FileWrite(handle, ServerAddress(), Symbol(), Period());                  // heading
        FileWrite(handle, "DATE","TIME","HIGH","LOW","CLOSE","OPEN","VOLUME");   // heading
        int i;
        for (i=length-1; i>=0; i--)
        {
          FileWrite(handle, TimeToStr(Time[i], TIME_DATE), TimeToStr(Time[i], TIME_SECONDS),
                            High[i], Low[i], Close[i], Open[i], Volume[i]);
        }
        FileClose(handle);
        Print("File "+nameData+" has been created. "+TimeToStr(TimeCurrent(), TIME_SECONDS) );
}

